/*
 *  Copyright (C) 2008-2011 The Android Open Source Project
 *  Copyright 2013 Sony Corporation
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */
/*
 * ChangeLog:
 *   2012-2013 changed by Sony Corporation
 */
#ifndef ANDROID_AUDIO_HW_ICX_H_
#define ANDROID_AUDIO_HW_ICX_H_

#include "android_audio_hw_icx_common.h"

/*----------------------------------------------------------------------------*/
typedef struct audio_device_ audio_device;

/*----------------------------------------------------------------------------*/
int      adev_set_a2dp_sink(audio_device* adev, const char* new_addr);
char*    adev_get_a2dp_addr(audio_device* adev);
uint64_t adev_get_last_write_time(audio_device* adev);
void     adev_set_last_write_time(audio_device* adev, uint64_t time);

/*----------------------------------------------------------------------------*/
void adev_wakeup(void);
void adev_set_fade(uint32_t mute_time_ms);
void adev_set_stream_fade(stream_type stype, uint32_t mute_time_ms);


#endif  /* ANDROID_AUDIO_HW_ICX_H_ */
