/*
 *  Copyright 2013 Sony Corporation
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU Lesser General Public License as published by
 *  the Free Software Foundation;  version 2.1 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU Lesser General Public License
 *  along with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Suite 500, Boston, MA 02110-1335, USA.
 *
 */
#ifdef ENABLE_DATA_DUMP

#ifndef ANDROID_AUDIO_HW_ICX_DUMP_H_
#define ANDROID_AUDIO_HW_ICX_DUMP_H_

/*----------------------------------------------------------------------------*/
#include "android_audio_hw_icx_common.h"

/*----------------------------------------------------------------------------*/
#define DATA_DUMP_PROP        "debug.sony.dump_icxaudio"
#define DATA_DUMP_FILE_FORMAT "/data/misc/camera/BT_HAL_%s_%s_%s_%s.pcm"

/* "all" is also available and "OUT" will be selected */
#define KEY_STD "bthal_std"
#define KEY_ICX "bthal_icx"
#define KEY_OUT "bthal_out"

/*----------------------------------------------------------------------------*/
typedef enum {
    DTYPE_STD = 0,
    DTYPE_ICX,
    DTYPE_OUT
} dump_type;

/*----------------------------------------------------------------------------*/
void open_dump_file(dump_type dtype, uint32_t sampling_rate, uint32_t frame_byte_size);
void close_dump_file(dump_type dtype);
void write_to_dump(dump_type dtype, const void* buffer, uint size);

#endif  /* ANDROID_AUDIO_HW_ICX_DUMP_H_ */

#endif  /* ENABLE_DATA_DUMP */
