/*
 *  Copyright 2013 Sony Corporation
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU Lesser General Public License as published by
 *  the Free Software Foundation;  version 2.1 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU Lesser General Public License
 *  along with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Suite 500, Boston, MA 02110-1335, USA.
 *
 */
#ifndef ANDROID_AUDIO_HW_ICX_SRC_H_
#define ANDROID_AUDIO_HW_ICX_SRC_H_

#include <stdint.h>

/*----------------------------------------------------------------------------*/
/* SRC processing frame num */
#define SRC_PROCESSING_FRAME_NUM 1024

/*----------------------------------------------------------------------------*/
int  SW_open(void);
void SW_close(void);

int  SW_initialize(uint32_t input_sample_rate,
                   uint32_t output_sample_rate);
void SW_finalize(void);
int  SW_get_max_output_frame_num(void);

/*
 * execute SRC
 *
 * @param input_buf        [in]  input buffer.  32bit 2ch PCM.
 * @param output_buf       [out] output buffer. 32bit 2ch PCM.
 * @param output_frame_num [out] frame num contained in output buffer.
 *
 * @retval 0    success.
 * @retval else error.
 */
int  SW_convert(const uint64_t* input_buf,
                uint64_t*       output_buf,
                int*            output_frame_num);


#endif  /* ANDROID_AUDIO_HW_ICX_SRC_H_ */
