/*
 *  Copyright 2013 Sony Corporation
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU Lesser General Public License as published by
 *  the Free Software Foundation;  version 2.1 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU Lesser General Public License
 *  along with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Suite 500, Boston, MA 02110-1335, USA.
 *
 */
#ifndef LIB_MIX_H_
#define LIB_MIX_H_

/*----------------------------------------------------------------------------*/
#include <stdint.h>

/*----------------------------------------------------------------------------*/
#define LIB_MIX_LOG_TAG_NAME "libmix"
#define LIB_MIX_SYMBOL_NAME  "HAL_LIB_MIX"

/*----------------------------------------------------------------------------*/
struct libmix {
    int (*initialize)(struct libmix* lm,
                      uint32_t       sampling_rate,
                      uint32_t       processing_frame_num);
    int (*finalize)(struct libmix* lm);
    uint32_t (*mix)(struct libmix* lm,
                    uint64_t*      input_a,
                    uint64_t*      input_b,
                    uint64_t*      out_buf,
                    uint32_t       count);
};

struct libmix_handle {
    int  (*get_libmix)(struct libmix** plm);
    void (*release_libmix)(struct libmix* lm);

    void* dso;
};

#endif  /* LIB_MIX_H_ */
